// GENERATED CONTENT - DO NOT EDIT MANUALLY!

part of '../tuple.dart';

/// A [Tuple] of 2 items.
@sealed
class Tuple2<I0, I1> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  @override
  List<Object?> get props => [i0, i1];

  /// Creates a [Tuple] of 2 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple); // "(0, 1)"
  /// ```
  const Tuple2(
    this.i0,
    this.i1,
  ) : super._();
}

/// A [Tuple] of 3 items.
@sealed
class Tuple3<I0, I1, I2> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  @override
  List<Object?> get props => [i0, i1, i2];

  /// Creates a [Tuple] of 3 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple); // "(0, 1, 2)"
  /// ```
  const Tuple3(
    this.i0,
    this.i1,
    this.i2,
  ) : super._();
}

/// A [Tuple] of 4 items.
@sealed
class Tuple4<I0, I1, I2, I3> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  @override
  List<Object?> get props => [i0, i1, i2, i3];

  /// Creates a [Tuple] of 4 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple); // "(0, 1, 2, 3)"
  /// ```
  const Tuple4(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
  ) : super._();
}

/// A [Tuple] of 5 items.
@sealed
class Tuple5<I0, I1, I2, I3, I4> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  @override
  List<Object?> get props => [i0, i1, i2, i3, i4];

  /// Creates a [Tuple] of 5 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4)"
  /// ```
  const Tuple5(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
  ) : super._();
}

/// A [Tuple] of 6 items.
@sealed
class Tuple6<I0, I1, I2, I3, I4, I5> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  @override
  List<Object?> get props => [i0, i1, i2, i3, i4, i5];

  /// Creates a [Tuple] of 6 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5)"
  /// ```
  const Tuple6(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
  ) : super._();
}

/// A [Tuple] of 7 items.
@sealed
class Tuple7<I0, I1, I2, I3, I4, I5, I6> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  @override
  List<Object?> get props => [i0, i1, i2, i3, i4, i5, i6];

  /// Creates a [Tuple] of 7 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6)"
  /// ```
  const Tuple7(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
  ) : super._();
}

/// A [Tuple] of 8 items.
@sealed
class Tuple8<I0, I1, I2, I3, I4, I5, I6, I7> extends Tuple {
  /// Item 0.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  @override
  List<Object?> get props => [i0, i1, i2, i3, i4, i5, i6, i7];

  /// Creates a [Tuple] of 8 items.
  ///
  /// # Examples
  ///
  /// ```dart
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7)"
  /// ```
  const Tuple8(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
  ) : super._();
}
